#include <math.h>
#include <stdbool.h>

// Schreiben Sie eine Funktion, der man
// die Koeffizienten a, b, c der quadratischen Gleichung
// ax + bx + c = 0 bergibt, und die dann
// eine (der ggf. zwei) Lsungen x zurckgibt.
// Was passiert, wenn es keine Lsung gibt?
// (Neue .c- und .h-Datei anlegen!)

double loese(double a, double b, double c)
{
  double p = b/a;
  double q = c/a;
  return -p/2.0 + sqrt(p*p/4.0 - q);
}

// Schreiben Sie eine Funktion,
// der man die Koeffizienten a, b, c
// der quadratischen Gleichung
// ax + bx + c = 0 bergibt,
// und die dann die Anzahl der Lsungen zurckgibt.

int zaehleLoesungen(double a, double b, double c)
{
  if(fabs(a) < 1e-20)
  {
    if(fabs(b) < 1e-20 && fabs(c) > 1e-20)
    {
      return 0;
    }
    return 1;
  }
  
  double p = b/a;
  double q = c/a;
  double d = p*p/4.0 - q;
  
  if(d > 1e-20)
  {
    return 2;
  }
  else if(d < -1e-20)
  {
    return 0;
  }
  
  return 1;
}

// Schreiben Sie eine Funktion, die den Sinus eines Winkels liefert,
// der in Grad angegeben ist.
// Anmerkung: In math.h auf unserem System fehlt
// das Symbol M_PI fr die Zahl pi.

static const double pi = 3.1415926535897932384626433832795;

double sinAusGrad(double x)
{
  double winkelInRad = x * pi / 180.0;
  return sin(winkelInRad);
}

// Schreiben Sie eine Funktion, der man ein Array
// aus double-Zahlen bergibt
// und die dann deren Mittelwert zurckliefert.

double bildeMittelwert(double a[], int laenge)
{
  double summe = 0.0;
  for(int i = 0; i < laenge; i++)
  {
    summe += a[i];
  }
  return summe/laenge;
}

// Schreiben Sie eine Funktion, der man ein Array
// aus ganzen Zahlen gibt.
// Jede Zahl kann mehrfach vorkommen, an beliebiger Stelle im Array.
// Nach Aufruf der Funktion sollen alle diese Zahlen
// nur noch jeweils einmal im Array stehen, und zwar lckenlos
// hintereinander. Die Anzahl dieser Zahlen soll der Rckgabewert
// der Funktion sein.

int filtere(int a[], int laenge)
{
  int zahlVerschiedene = 0;
  for(int i = 0; i < laenge; i++)
  {
    bool hattenWir = false;
    for(int j = 0; j < zahlVerschiedene; j++)
    {
      if(a[i] == a[j])
      {
        hattenWir = true;
        break;
      }
    }
    if(!hattenWir)
    {
      a[zahlVerschiedene] = a[i];
      zahlVerschiedene++;
    }
  }
  return zahlVerschiedene;
}
